// src/backend/dynamic_resource.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef DYNAMIC_RESOURCE_HH
#define DYNAMIC_RESOURCE_HH 1

#include "config.h"
#include "glibmm/ustring.h"

#include "smartp.hh"

#include "resource.hh"
#include "static_resource.hh"

namespace sgpem
{
  class DynamicResource;
  class SerializeVisitor;

  class SG_DLLLOCAL DynamicResource : public Resource
  {
  public:
    DynamicResource(StaticResource *core);

		virtual bool operator==(const Resource& op2) const;

    Glib::ustring get_name() const;
    unsigned int get_places() const;

    void serialize(SerializeVisitor& translator) const;

		StaticResource& get_core();
		const StaticResource& get_core() const;

  private:
    memory::smart_ptr<StaticResource> _static_resource;
  };

}

#endif

