// src/backend/plugin_manager.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PLUGIN_MANAGER_HH
#define PLUGIN_MANAGER_HH 1

namespace sgpem
{
  class Module;
}

#include "config.h"

#include "singleton.hh"

#include <vector>

namespace sgpem
{
  class PluginManager;
  
  class SG_DLLEXPORT PluginManager : public Singleton<PluginManager>
  {
    friend class Singleton<PluginManager>;
  public:
    std::vector<Module*> get_module_list() const;

    void rescan_dirs();

  private:
    PluginManager();

    std::vector<Module*> _modules; 

  }; //~ class PluginManager

} //~ namespace sgpem

#endif

