// src/backend/policy_manager.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#include "policy_manager.hh"
#include "policies_gatekeeper.hh"

PolicyManager*
PolicyManager::_registered = NULL;

PolicyManager::PolicyManager()
{
  //FIXME remove this when get_registered_manager is dropped
  _registered = this;

  PoliciesGatekeeper::get_instance().register_manager(this);
}


PolicyManager::~PolicyManager()
{
  // This check is necessary:
  //FIXME remove this when get_registered_manager is dropped
  if(_registered == this) _registered = NULL;

  PoliciesGatekeeper::get_instance().unregister_manager(this);
}

PolicyManager&
PolicyManager::get_registered_manager()
{
  return *_registered;
}

