// src/backend/resource.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef READY_QUEUE_HH
#define READY_QUEUE_HH 1

#include "config.h"

#include <stdexcept>
#include <vector>

namespace sgpem
{
	class ReadyQueue;
	class Thread;

  class SG_DLLEXPORT ReadyQueue
  {
  public:
		typedef unsigned int position;
		typedef unsigned int size_t;

		void       swap(position a, position b) throw (std::out_of_range);
		size_t     size() const;
		Thread&    get_item_at(position index) throw (std::out_of_range);
		void       append(Thread& schedulable);
		
  private:
		typedef std::vector<Thread*> Threads;
		Threads _scheds;
  };

}

#endif

