// src/backend/static_process.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "static_process.hh"
using namespace sgpem;


StaticProcess::StaticProcess(const Glib::ustring& name, const unsigned int& arrival, const int& priority)
	: StaticSchedulable(name, priority), _start_time(arrival)
{}


StaticProcess::~StaticProcess()
{}


unsigned int
StaticProcess::get_arrival_time() const
{
	return _start_time;
}


unsigned int
StaticProcess::get_total_cpu_time() const
{
	typedef std::vector<StaticThread*>::const_iterator ThreadIterator;

	unsigned int result = 0;
	for(ThreadIterator it = _threads.begin(); it != _threads.end(); it++)
		result += (*it)->get_total_cpu_time();
	return result;
}


std::vector<StaticThread*>& 
StaticProcess::get_threads()
{
	return _threads;
}
