// src/backend/static_request.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STATIC_REQUEST_HH
#define STATIC_REQUEST_HH 1

#include "static_thread.hh"

#include "config.h"
#include "glibmm/ustring.h"

namespace sgpem
{
  class StaticRequest;
  class SerializeVisitor;

  class SG_DLLLOCAL StaticRequest
  {
  public:
    StaticRequest(StaticThread* thread, unsigned int instant);
    ~StaticRequest();

    unsigned int get_instant() const;
    StaticThread& get_thread();

  private:
    StaticRequest(const StaticRequest&);

    StaticThread* _thread;
    unsigned int _instant;
  };

}

#endif

