// src/backend/static_resource.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STATIC_RESOURCE_HH
#define STATIC_RESOURCE_HH 1

#include "config.h"
#include "glibmm/ustring.h"

namespace sgpem
{
  class StaticResource;
  class SerializeVisitor;

  class SG_DLLLOCAL StaticResource
  {
  public:
    StaticResource(const Glib::ustring& name, unsigned int places = 1);

    Glib::ustring get_name() const;
    unsigned int get_places() const;

  private:
    StaticResource(const StaticResource&);

    Glib::ustring _name;
    unsigned int _places;
  };

}

#endif

