// src/backend/static_sub_request.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STATIC_SUB_REQUEST_HH
#define STATIC_SUB_REQUEST_HH 1

#include "config.h"

#include "sub_request.hh"

namespace sgpem
{
  class StaticSubRequest;
  class StaticRequest;
  class StaticResource;

  class SG_DLLLOCAL StaticSubRequest
  {
  public:
    typedef SubRequest::resource_key_t resource_key_t;

    StaticSubRequest(resource_key_t resource_key,
                     unsigned int length);

    ~StaticSubRequest();

    resource_key_t get_resource_key() const;

    unsigned int get_length() const;

  private:
    StaticSubRequest(const StaticSubRequest&);
    StaticSubRequest& operator=(const StaticSubRequest&);

    resource_key_t _resource_key;
    unsigned int _length;
  };

}

#endif

