// src/backend/string_utils.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STRING_UTILS_HH
#define STRING_UTILS_HH 1

#include "config.h"
#include <sstream>
#include <iostream>
#include <vector>
#include <stdexcept>
#include <glibmm/ustring.h>

// FIXME : mark this file as deprecated.
#warning "This file is obsolete and deprecated."
#warning "It will be removed soon. Please update your code!"

namespace sgpem
{
  typedef std::vector<Glib::ustring> Tokens;
  
  /**\brief This function tries to convert a string into an integer value.

   The string can contain only digits and the minus character (for negative numbers).

   \returns TRUE if ths string represent a valid integer number
   \returns FALSE otherwise
  */
  bool SG_DLLEXPORT string_to_int(const Glib::ustring&, int&);

  template <typename T>
  T SG_DLLEXPORT string_to(const Glib::ustring&) throw(std::domain_error);

  /**\brief This function converts an integer value into a string.

   There is no return value because this function always succeeds.
  */
  void SG_DLLEXPORT int_to_string(const int&, Glib::ustring&);


  /**\brief This function converts a float value into a string.

   There is no return value because this function always succeeds.
  */
  void SG_DLLEXPORT float_to_string(const float&, Glib::ustring&);


  /**\brief This function tries to convert a string into a float value.

   The string can contain only digits, the minus, plus and dot (-+.) characters. If not,
   the value 0 is assigned.

   There is no return value because this function always succeeds, even if the string is badly formed.
  */
  void SG_DLLEXPORT string_to_float(const Glib::ustring&, float&);

  Tokens SG_DLLEXPORT tokenize(const Glib::ustring& str);
}

#endif
