// src/graphical_simulation.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef GRAPHICAL_SIMULATION_HH
#define GRAPHICAL_SIMULATION_HH 1

#include "config.h"
#include "gettext.h"

#include <gtkmm/box.h>
#include <gtkmm/window.h>
#include <glibmm/ustring.h>

#include "simulation.hh"
#include "text_simulation.hh"
#include "io_manager.hh"
#include "graphical_terminal_io.hh"

namespace sgpem
{


  class GraphicalSimulation;

  /** \brief Concrete \ref Simulation subclass with a GUI.

      The GraphicalSimulation class is only a placeholder for the future baselines.  
   */
  class GraphicalSimulation : public Simulation
  {
  public:
    GraphicalSimulation();

    /**
    Visualize the state of the simulation in a graphic mode
     */
    void update();

  };

}

#endif
