// src/gui_builder.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef GUI_BUILDER_HH
#define GUI_BUILDER_HH 1

#include "config.h"

#include <gtkmm/window.h>
#include <libglademm/xml.h>

#include <string>

/** \brief This class initialize and starts the whole GUI
 
*/
namespace sgpem {

	class GuiBuilder
	{
	public:
		GuiBuilder(const std::string& gladefile = GLADEDIR "/main-window.glade");
		~GuiBuilder();
		
		Gtk::Window& get_initial_window() const;
		void open_file(const std::string& filename);
		
	private:
		Glib::RefPtr<Gnome::Glade::Xml> _refXml;		
	};

} //~ namespace sgpem

#endif //~ GUI_BUILDER_HH

