// src/mainwindow.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "config.h"
#include "gettext.h"

#include "main_window.hh"

#include <gtkmm/box.h>
#include <gtkmm/button.h>
#include <gtkmm/main.h>
#include <gtkmm/menubar.h>
#include <gtkmm/window.h>

using namespace sgpem;

MainWindow::MainWindow()
{
  set_title(PACKAGE_STRING);
  //set_default_size(800, 600);

  Gtk::Box* mainbox = manage(new Gtk::VBox());
  add(*mainbox);

  Gtk::Button* bt_exit = manage(new Gtk::Button(_("Exit")));
  bt_exit->signal_clicked().connect(sigc::ptr_fun(Gtk::Main::quit));
  mainbox->pack_start(*bt_exit);

  show_all_children();
}

MainWindow::~MainWindow()
{}

