// src/parseopts.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PARSEOPTS_HH
#define PARSEOPTS_HH 1

/** \brief Parses command line options
 *
 * Parses command line options and sets argv to the first filename 
 *  given to the cmdline. 
 *  If no filename is given, in the end argc will be 0.
 *
 *  Else argc will contain the length of the remaining argv[].
 *
 *  If you still need the initial values of the global argc and argv
 *  passed to the main routine, remember to store them somewhere before
 *  calling this function.
 *  \param argc The number of elements of the argv array
 *  \param argv The array of command line parameter strings
 */
void parse_options(int argc, char** argv);

/** \brief Prints license notice text to stderr */
void print_license();

#endif

