// src/schedulables_widget.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SCHEDULABLES_WIDGET_HH
#define SCHEDULABLES_WIDGET_HH 1

#include "config.h"

#include "backend/history_observer.hh"

#include <gtkmm/drawingarea.h>

namespace sgpem
{
  class SchedulablesWidget : public Gtk::DrawingArea, public HistoryObserver
  {
  public:
    SchedulablesWidget();
    virtual ~SchedulablesWidget();

    void update(const History& history);

  protected:
    virtual void on_size_request(Gtk::Requisition* requisition);
    virtual bool on_expose_event(GdkEventExpose* event);
    virtual bool on_button_press_event(GdkEventButton* event);

  private:
    typedef Gdk::Rectangle                               area_t;
    typedef sigc::mem_functor0<void, SchedulablesWidget> method0_t;
    typedef std::pair<area_t, method0_t>                 area_callback_t;
    typedef std::vector<area_callback_t>                 areas_vect_t;
    
    cairo_t*  _ctx;
  };

} //~ namespace sgpem


#endif //~ SCHEDULABLES_WIDGET_HH
