// src/standard_io.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "standard_io.hh"

using namespace std;
using namespace sgpem;
using Glib::ustring;

uint
StandardIO::write_buffer(const ustring& buffer)
{
  cout << buffer;
  cout.flush();
  if (cout.good())
    return buffer.length();
  else
    return 0;
}

ustring
StandardIO::read_command()
{
  using namespace std;

  char p[2000];
  cin.getline(p, 2000);

  ustring command(p);

  static const ustring whitespaces = " \r\b\n\t\a";
  // are there any other wspaces?
  // trimming:
  uint f = command.find_first_not_of(whitespaces);
  uint l = command.find_last_not_of(whitespaces);
  if(f == ustring::npos)
    return "";

  return command.substr(f, l - f + 1);
}

bool
StandardIO::is_full_duplex()
{
  return false;
}
