// src/testsuite/test-stepforward.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef HISTORY_HH
#define HISTORY_HH 1

#include "backend/observed_subject.hh"
#include "backend/slice.hh"
#include "backend/ready_queue.hh"
#include "templates/smartp.tcc"
#include <iostream>

/*
#include <glibmm/module.h> // ??
#include <cassert>
#include <string>
#include "config.h"
#include "gettext.h"
#include "glibmm/ustring.h"
#include <vector>

#include "backend/static_process.hh"


#include "backend/dynamic_schedulable.hh"

#include "backend/user_interrupt_exception.hh"
#include "backend/policy.hh"

#include "prrpolicy.cc"
#include <iostream>
*/

namespace sgpem
{

    /** an History stub, should only save the last state included.
     */
    class History : public ObservedSubject
    {

    public:


        /** Returns the DynamicSchedulable of the schedulable
         * which was running at the time, if any.
         */
        memory::smart_ptr<sgpem::DynamicSchedulable>
        get_scheduled_at(int time) const;


        /** Returns the last recorded instant, but may raise an error.
         */
        memory::smart_ptr<sgpem::ReadyQueue>
        get_simulation_status_at(int time) const;


        /** Returns the total time recorded.
         */
        int
        get_current_time() const;


        /** Extends the recorded history by one unit, overwriting the old value
         */
        void
        enqueue_slice(const sgpem::ReadyQueue& status);


        /** STUB: THIS FEATURE IS NOT AVAILABLE
         */
        void
        truncate_at(int instant);


        /** Returns the singleton instance.
         */
        static History&
        get_instance();


    private:
        History();

        static History * _instance;
        int _total_time_elapsed;
        memory::smart_ptr<Slice> _slice;
    };


} //~ namespace sgpem

#endif
