// src/testsuite/test-stepforward.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PRRPOLICY_HH
#define PRRPOLICY_HH 1

#include "backend/policy.hh"
#include "backend/user_interrupt_exception.hh"
#include "backend/ready_queue.hh"
#include "backend/scheduler.hh"
#include "glibmm/ustring.h"

/*
#include <string>
#include "config.h"
#include "gettext.h"

#include <vector>
#include <iostream>
#include "backend/static_process.hh"
#include "backend/observed_subject.hh"

#include "backend/dynamic_schedulable.hh"
#include "templates/smartp.tcc"
#include "backend/user_interrupt_exception.hh"

#include "backend/slice.hh"

#include <iostream>
*/

namespace sgpem
{
    /** An hard-coded Priority Round Robin policy
     * It's actually called PRRPolicy, altough my personal taste would have suggested 
     * naming it 
     * Prioriy-Reliant Roughly-Realized Recently-Reimplemented Round-Robin Policy, 
     * i.e. PRRRRRRR-Policy.
     * it adds a new constructor taking the quantum size (time slice)
     */
    class PRRPolicy : public Policy
    {
        public:

            PRRPolicy();

            PRRPolicy(int quantum);

        static Policy&
                get_instance();
        
        virtual
                ~PRRPolicy();

        virtual void
        configure()
                throw(UserInterruptException);

        virtual void
        sort_queue() const
                throw(UserInterruptException);


        virtual void 
                activate();

        virtual void 
                deactivate();
        
        
        virtual int
                get_id() const;
        
        virtual sgpem::policy_sorts_type
                wants() const
                throw(UserInterruptException);
        
        
        virtual Glib::ustring
                get_name() const;

        virtual Glib::ustring
                get_description() const;

        virtual bool
        is_pre_emptive() const
                throw(UserInterruptException);

        virtual int
        get_time_slice() const
                throw(UserInterruptException);


        virtual PolicyParameters&
                get_parameters();



        protected:

        PolicyParameters _parameters;
        int _id;
        int _quantum;

        private:

        static Policy* _instance;
    };

}

#endif
